﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ProgressExamples
{
    public class Worker
    {
        public string Name { get; } //nazwa by rozpoznać naszego pracownika / name to recognize our worker
        public Worker(string name) //konstruktor wymuszający podanie nazwy / constructor forcing a name
        {
            Name = name;
        }


        /// <summary>
        /// Metoda tworząca i zwracająca task. Metoda ta raportuje za pomocą interfejsu IProgress<int>
        /// A method that creates and returns a task. This method reports using the IProgress <int> interface
        /// </summary>
        /// <param name="howMany"></param>
        /// <param name="progress"></param>
        /// <returns></returns>
        public Task PracaAsync(int howMany, IProgress<int> progress)
        {
            Console.WriteLine($"Worker {Name} start working....");
            Task t = new Task(() =>
            {
                for (int i = 1; i <= howMany; i++)
                {
                    Thread.SpinWait(100000000);
                  //  Console.WriteLine($"Worker {Name} produced  {i}");
                    if (progress!=null) progress.Report(i); //specyfikacja metod asynchronicznych dopuszcza by jako progress dać null, więc musimy to sprawdzić./ the specification of async methods allows null as progress, so we need to check it.
                }
                Console.WriteLine($"Worker {Name} finished work");
            });
            t.Start(); 
            return t;
        }

        /// <summary>
        /// Metoda tworząca i zwracająca task. Metoda ta raportuje za pomocą interfejsu IProgress zwracającego string
        /// A method that creates and returns a task. This method reports using the IProgress interface that returns a string
        /// </summary>
        /// <param name="howMany"></param>
        /// <param name="progress"></param>
        /// <returns></returns>
        public Task PracaAsync(int howMany, IProgress<string> progress)
        {
            Console.WriteLine($"Worker {Name} start working....");
            Task t = new Task(() =>
            {
                for (int i = 1; i <= howMany; i++)
                {
                    Thread.SpinWait(100000000);
                    if (progress != null) progress.Report($"Worker {Name} reports element {i}"); //tu zwracamy od razu cały string / here we return the entire string.
                }
                Console.WriteLine($"Worker {Name} finished work");
            });
            t.Start();
            return t;
        }
    }
}
