﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace TAP
{
    public enum NaCoSkladniki
    {
       NaBiszkopt,
       NaKrem
    }

    

    public class Kucharz
    {

        public string Nazwa { get; }
        public Kucharz(string nazwa)
        {
            Nazwa = nazwa;
        }

        CancellationTokenSource ctsInternal = new CancellationTokenSource();

        private async Task<List<string>> dodaj(string co, List<string> skladniki,int jakDlugo, CancellationToken cts)
        {

           using (CancellationTokenSource linkedCts = CancellationTokenSource.CreateLinkedTokenSource(ctsInternal.Token, cts))
            {
                try
                {
                    var heavyTask = LoadCreator.MakeSomeLoadAsync(linkedCts.Token);
                    ctsInternal.CancelAfter(jakDlugo);
                    await heavyTask;
                }
                catch (OperationCanceledException)
                {
                    // Console.WriteLine("heavyTask status: {0}", heavyTask.Status);
                }
                catch (AggregateException aex)
                {
                    Console.WriteLine("Złapany wyjątek AggregateException: " + aex.InnerException);
                    foreach (var inner in aex.InnerExceptions)
                    {
                        Console.WriteLine(inner.Message + inner.Source);
                    }
                }
            }
            skladniki.Add(co);
            return skladniki;
         //   Console.WriteLine($"Składnik {co} został dodany");
        }


        public async Task<List<string>> przygotujSkladniki(NaCoSkladniki naCoskladniki, CancellationToken cts)
        {
           return await przygotujSkladniki(naCoskladniki, 10, cts);
        }

        public async Task<List<string>> przygotujSkladniki(NaCoSkladniki naCoSkladniki, int jakDlugo, CancellationToken cts)
            {
            Console.WriteLine($"Kucharz {Nazwa} przygotowuje składniki {naCoSkladniki}");
            List<string> skladniki = new List<string>();
         //   CancellationTokenSource cts;
          //  using (cts = new CancellationTokenSource()) //konstrukca używana dla obiektów disposable (pod koniec bloku using obiekt jest usuwany, w celu utworzenia nowego.
         //   {
                switch (naCoSkladniki)
                {
                    case NaCoSkladniki.NaBiszkopt:
                        {
                        int jakDlugoNaSkladnik = jakDlugo * 1000 / 5;
                        skladniki = await dodaj("mąka",  skladniki, jakDlugoNaSkladnik,cts);
                        skladniki = await dodaj("jajka",  skladniki, jakDlugoNaSkladnik, cts);
                        skladniki = await dodaj("woda",  skladniki, jakDlugoNaSkladnik, cts);
                        skladniki = await dodaj("cukier",  skladniki, jakDlugoNaSkladnik, cts);
                        skladniki = await dodaj("mleko",  skladniki, jakDlugoNaSkladnik, cts);
                        }
                        break;
                    case NaCoSkladniki.NaKrem:
                        {
                        int jakDlugoNaSkladnik = jakDlugo * 1000 / 4;
                        var taskDodajCukier = dodaj("cukier",  skladniki, jakDlugoNaSkladnik, cts);
                        skladniki = taskDodajCukier.Result;
                        taskDodajCukier.Dispose();
                        var taskDodajSmietane = dodaj("śmietana",  skladniki, jakDlugoNaSkladnik, cts);
                        skladniki = taskDodajSmietane.Result;
                        taskDodajSmietane.Dispose();
                      //  skladniki =  dodaj("serek",  skladniki, jakDlugoNaSkladnik, cts).Result;
                       // skladniki =  dodaj("białko",  skladniki, jakDlugoNaSkladnik, cts).Result;

                        }
                        break;
                    default:
                        break;
                }
        //    }
          
            Console.WriteLine($"Kucharz {Nazwa} skończył przygotowywać składniki {naCoSkladniki}");
            return skladniki;
        }


        public void zrobTort(string biszkopt, string krem)
        {
            zrobTort(biszkopt, krem, 20);
        }
        public void zrobTort(string biszkopt, string krem, int jakDlugo)
        {
            Thread.Sleep(jakDlugo);
        }
    }
}
