﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace TAP
{
    public class Lodowka
    {
        public string Name { get; }

        public Lodowka(string nazwa)
        {
            Name = nazwa;
        }

        private void schlodzSkladniki(ref List<string> skladniki)
        {
            for (int i = 0; i < skladniki.Count(); i++)
            {
                skladniki[i] += " - schlodzony";
            }
        }


        public async Task<List<string>> SchlodzSkladnikiAsync(int sekundy, List<string> skladniki, IProgress<int> progress, CancellationToken cancellationToken)
        {
            Console.WriteLine($"Lodówka {Name} zaczyna schładzanie");
            //gdy nie mamy skladników to nic nie robimy tylko od razu je zwracamy
            if (skladniki.Count == 0)
            {
                Console.WriteLine($"Lodówka {Name} brak składników!!!");
                return skladniki;
            }
            else
            {
                CancellationTokenSource cts;
                for (int i = 1; i <= sekundy; i++)
                {

                    using (cts = new CancellationTokenSource()) //konstrukca używana dla obiektów disposable (pod koniec bloku using obiekt jest usuwany, w celu utworzenia nowego.
                    {
                        var heavyTask = LoadCreator.MakeSomeLoadAsync(cts.Token);
                        if (cancellationToken.IsCancellationRequested)
                        {
                            Console.WriteLine($"Wyłączam lodowka {Name}");
                            cts.Cancel(); //zakończ proces obciążający
                            return skladniki;
                        }

                        try
                        {
                            cts.CancelAfter(1000); //po 1 sekundzie zakończ proces obciążający
                            await heavyTask;
                        }
                        catch (OperationCanceledException)
                        {
                            // Console.WriteLine("heavyTask status: {0}", heavyTask.Status);
                        }
                    }
                    progress.Report(i);
                }
                schlodzSkladniki(ref skladniki); //tylko formalność
                Console.WriteLine($"Składniki schłodzone przez lodówkę {Name}");
                foreach (var skladnik in skladniki)
                {
                    Console.WriteLine(skladnik);
                }
                return skladniki;
            }

        }
    }
}
