﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TaskSchedulerExample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {


        Progress<int> progress = null;
        TaskScheduler _uiScheduler;
        public MainWindow()
        {
            InitializeComponent();
            //define the action triggered with the reported progress
            progress = new Progress<int>(percent =>
            {
                progressBar.Value = percent;
               
            });
            _uiScheduler = TaskScheduler.FromCurrentSynchronizationContext();
        }

        private void GoBT_Click(object sender, RoutedEventArgs e)
        {
            var client = new HttpClient();
            //Task.Factory.StartNew<string>(SomeMethodLongReturningData)
            //    .ContinueWith(ant =>
            //    {
            //        contentViewer.AppendText(ant.Result);
            //    }, _uiScheduler);
            string url = new TextRange(contentViewer.Document.ContentStart, contentViewer.Document.ContentEnd).Text;
            Task downloading = client.GetStringAsync(url)
            .ContinueWith(ant =>
            {
                string ret = ant.Result;

                rtb.AppendText(ret);
            }, _uiScheduler);
        }

        /// <summary>
        /// Normal task that takes a long time
        /// </summary>
        /// <returns></returns>
        private string SomeMethodLongReturningData()
        {
            Thread.Sleep(5000); return "Here we have data...";
        }

        /// <summary>
        /// The task takes a long time and reports progress
        /// </summary>
        /// <param name="progress"></param>
        /// <returns></returns>
        private Task<string> SomeMethodLongReturningDataAsync(IProgress<int> progress)
        {
           return Task.Factory.StartNew<string>(() =>
            {
                for (int i = 1; i <= 10; i++)
                {
                    Thread.Sleep(500);
                    progress.Report(i);
                }
                return "Here we have data with progress...";
            });
        }

        /// <summary>
        /// An example of a method that returns data with progress reporting
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void GoWithProgress_Click(object sender, RoutedEventArgs e)
        {
            SomeMethodLongReturningDataAsync(progress)
               .ContinueWith(ant => {
                   contentViewer. AppendText(ant.Result);
               }, _uiScheduler);
        }
    }
}
